﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EventTest
{
    public delegate void MyButtonEventHandler(); // delegate event
    public delegate void ClickEventHandler(string label); // delegate event

    public class MyButton
    {
        public event MyButtonEventHandler MyButtonEvent;    // event
        public void OnMyButtonEvent()                 // event generator calls event handler
        {
            if (MyButtonEvent != null)
            {
                MyButtonEvent();
            }
        }

        string label;                           // event args
        public string Label
        {
            set
            {
                label = value;
            }
            get
            {
                return label;
            }
        }
        public event ClickEventHandler ClickEvent; // event
        public void OnClickEvent()                 // event generator calls event handler
        {
            if (ClickEvent != null)
            {
                ClickEvent(label);
            }
        }
    }
}
